import { Query } from "./Query";
declare const simpsons: {
    readonly people: readonly [{
        readonly id: 1;
        readonly firstName: "Bart";
        readonly lastName: "Simpson";
        readonly isChild: true;
    }, {
        readonly id: 2;
        readonly firstName: "Lisa";
        readonly lastName: "Simpson";
        readonly isChild: true;
    }, {
        readonly id: 3;
        readonly firstName: "Maggie";
        readonly lastName: "Simpson";
        readonly isChild: true;
    }, {
        readonly id: 4;
        readonly firstName: "Marge";
        readonly lastName: "Simpson";
        readonly isChild: false;
    }, {
        readonly id: 5;
        readonly firstName: "Homer";
        readonly lastName: "Simpson";
        readonly isChild: false;
    }, {
        readonly id: 6;
        readonly firstName: "Montgomery";
        readonly lastName: "Burns";
        readonly isChild: false;
    }, {
        readonly id: 7;
        readonly firstName: "Whelan";
        readonly lastName: "Smithers";
        readonly isChild: false;
    }, {
        readonly id: 8;
        readonly firstName: "Nillhouse";
        readonly lastName: "Van Houten";
        readonly isChild: true;
    }, {
        readonly id: 9;
        readonly firstName: "Nelson";
        readonly lastName: "Muntz";
        readonly isChild: true;
    }, {
        readonly id: 10;
        readonly firstName: "Principal";
        readonly lastName: "Skinner";
        readonly isChild: false;
    }];
    readonly places: readonly [{
        readonly name: "Springfield Elementary";
        readonly ownerId: 10;
        readonly isActive: true;
    }, {
        readonly name: "Nuclear Power Plant";
        readonly ownerId: 6;
        readonly isActive: true;
    }, {
        readonly name: "Evergreen Terrace";
        readonly ownerId: 4;
        readonly isActive: true;
    }, {
        readonly name: "Monorail";
        readonly ownerId: 8;
        readonly isActive: false;
    }, {
        readonly name: "Treehouse of Horror";
        readonly ownerId: 1;
        readonly isActive: true;
    }, {
        readonly name: "Playground";
        readonly ownerId: 9;
        readonly isActive: true;
    }];
};
export declare type DBv1 = typeof simpsons;
export declare type EX1 = Query<"SELECT firstName FROM people WHERE lastName = 'Simpson'", DBv1>;
export declare type EX2 = Query<"SELECT firstName, lastName FROM people WHERE isChild = true", DBv1>;
export declare type EX3 = Query<"SELECT * FROM people WHERE isChild = false AND firstName LIKE 'M%'", DBv1>;
export declare type DBv2 = Query<"UPDATE people SET firstName = 'Milhouse' WHERE id = 8", DBv1>;
export declare type EX4 = Query<"SELECT * FROM people WHERE id = 8", DBv2>;
export declare type DBv3 = Query<"INSERT INTO people SET id = 11, firstName = 'Troy', lastName = 'McClure', isChild = false", DBv2>;
export declare type EX5 = Query<"SELECT * FROM people WHERE firstName = 'Troy'", DBv3>;
export declare type DBv4 = Query<"DELETE FROM people WHERE firstName = 'Troy' AND lastName = 'McClure'", DBv3>;
export declare type EX6 = Query<"SELECT firstName FROM people WHERE isChild = false", DBv4>;
export declare type DBv5 = Query<"INSERT INTO people SET id = 11, firstName = 'Moe', lastName = 'Szyslak', isChild = false", DBv4>;
export declare type EX7 = Query<"SELECT id, firstName FROM people WHERE isChild = false AND firstName LIKE 'M%'", DBv5>;
export declare type DBv6 = Query<'INSERT INTO places SET name = "Moe\'s Tavern", ownerId = 11, isActive = true', DBv5>;
export declare type EX9 = Query<"SELECT name, person.firstName, person.lastName FROM places INNER JOIN people AS person ON places.ownerId = person.id", DBv1>;
export {};
